package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public static String _strmodel = "";
public static String _strdevicecode = "";
public static anywheresoftware.b4a.sql.SQL _conkha = null;
public static anywheresoftware.b4a.sql.SQL.CursorWrapper _tmprst = null;
public static String _strdatapath = "";
public static String _strreport_path = "";
public static String _strrpt = "";
public static String _strfilename = "";
public static com.rootsoft.oslibrary.OSLibrary _os = null;
public static String _strmessage = "";
public static String _strassignto = "";
public static String _strdate = "";
public static boolean _editmode = false;
public anywheresoftware.b4a.objects.ListViewWrapper _lstmessage = null;
public b4a.example.starter _starter = null;
public b4a.example.frmtodomain _frmtodomain = null;
public b4a.example.frmtodoentry _frmtodoentry = null;
public static class _listviewdata{
public boolean IsInitialized;
public String FirstRow;
public String SecondRow;
public void Initialize() {
IsInitialized = true;
FirstRow = "";
SecondRow = "";
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
vis = vis | (frmtodomain.mostCurrent != null);
vis = vis | (frmtodoentry.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 41;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 44;BA.debugLine="Activity.LoadLayout(\"FrmTodoMain\")";
mostCurrent._activity.LoadLayout("FrmTodoMain",mostCurrent.activityBA);
 //BA.debugLineNum = 46;BA.debugLine="StrModel = OS.Model.ToUpperCase";
_strmodel = _os.getModel().toUpperCase();
 //BA.debugLineNum = 47;BA.debugLine="EditMode = False";
_editmode = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 50;BA.debugLine="ConKha.Initialize(File.DirRootExternal & \"/DataDi";
_conkha.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal()+"/DataDir/Data/","Config.S3db",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 52;BA.debugLine="TmpRst = ConKha.ExecQuery(\"Select Code from Devic";
_tmprst.setObject((android.database.Cursor)(_conkha.ExecQuery("Select Code from Device Where RTrim(ModelNo) = '"+_strmodel+"' ")));
 //BA.debugLineNum = 53;BA.debugLine="If TmpRst.RowCount >0 Then";
if (_tmprst.getRowCount()>0) { 
 //BA.debugLineNum = 54;BA.debugLine="TmpRst.Position = 0";
_tmprst.setPosition((int) (0));
 //BA.debugLineNum = 55;BA.debugLine="StrDeviceCode = TmpRst.GetString(\"Code\")";
_strdevicecode = _tmprst.GetString("Code");
 }else {
 //BA.debugLineNum = 57;BA.debugLine="StrDeviceCode  = \"2\"";
_strdevicecode = "2";
 };
 //BA.debugLineNum = 60;BA.debugLine="TmpRst.Close";
_tmprst.Close();
 //BA.debugLineNum = 62;BA.debugLine="TmpRst = ConKha.ExecQuery(\"Select * from Config W";
_tmprst.setObject((android.database.Cursor)(_conkha.ExecQuery("Select * from Config Where D_Code = "+_strdevicecode+" ")));
 //BA.debugLineNum = 63;BA.debugLine="TmpRst.Position = 0";
_tmprst.setPosition((int) (0));
 //BA.debugLineNum = 64;BA.debugLine="StrDataPath =  TmpRst.GetString(\"PDesc\")";
_strdatapath = _tmprst.GetString("PDesc");
 //BA.debugLineNum = 65;BA.debugLine="TmpRst.Position = 13";
_tmprst.setPosition((int) (13));
 //BA.debugLineNum = 66;BA.debugLine="StrReport_Path = TmpRst.GetString(\"PDesc\")";
_strreport_path = _tmprst.GetString("PDesc");
 //BA.debugLineNum = 67;BA.debugLine="TmpRst.Close";
_tmprst.Close();
 //BA.debugLineNum = 68;BA.debugLine="ConKha.Close";
_conkha.Close();
 //BA.debugLineNum = 70;BA.debugLine="ConKha.Initialize(StrDataPath,\"Diary.S3db\",True)";
_conkha.Initialize(_strdatapath,"Diary.S3db",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 72;BA.debugLine="Activity.AddMenuItem(\"Add Todo\",\"FrmToDoEntry\")";
mostCurrent._activity.AddMenuItem(BA.ObjectToCharSequence("Add Todo"),"FrmToDoEntry");
 //BA.debugLineNum = 74;BA.debugLine="LstMessage.TwoLinesLayout.Label.TextColor = Color";
mostCurrent._lstmessage.getTwoLinesLayout().Label.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 75;BA.debugLine="LstMessage.TwoLinesLayout.ItemHeight = 50dip";
mostCurrent._lstmessage.getTwoLinesLayout().setItemHeight(anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (50)));
 //BA.debugLineNum = 77;BA.debugLine="LstMessage.TwoLinesLayout.SecondLabel.TextColor =";
mostCurrent._lstmessage.getTwoLinesLayout().SecondLabel.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Red);
 //BA.debugLineNum = 78;BA.debugLine="LstMessage.TwoLinesLayout.Label.TextSize = 15";
mostCurrent._lstmessage.getTwoLinesLayout().Label.setTextSize((float) (15));
 //BA.debugLineNum = 79;BA.debugLine="LstMessage.TwoLinesLayout.SecondLabel.TextSize =";
mostCurrent._lstmessage.getTwoLinesLayout().SecondLabel.setTextSize((float) (12));
 //BA.debugLineNum = 80;BA.debugLine="LstMessage.ScrollingBackgroundColor = Colors.Tran";
mostCurrent._lstmessage.setScrollingBackgroundColor(anywheresoftware.b4a.keywords.Common.Colors.Transparent);
 //BA.debugLineNum = 82;BA.debugLine="ExecuteListView";
_executelistview();
 //BA.debugLineNum = 84;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 92;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 95;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 88;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 89;BA.debugLine="ExecuteListView";
_executelistview();
 //BA.debugLineNum = 90;BA.debugLine="End Sub";
return "";
}
public static String  _executelistview() throws Exception{
int _j = 0;
b4a.example.main._listviewdata _lvd = null;
 //BA.debugLineNum = 101;BA.debugLine="Sub ExecuteListView()";
 //BA.debugLineNum = 103;BA.debugLine="TmpRst = ConKha.ExecQuery(\"Select Message,AssignT";
_tmprst.setObject((android.database.Cursor)(_conkha.ExecQuery("Select Message,AssignTo,LogDate from Todo Where Active = 0")));
 //BA.debugLineNum = 104;BA.debugLine="LstMessage.Clear";
mostCurrent._lstmessage.Clear();
 //BA.debugLineNum = 105;BA.debugLine="For J = 0 To TmpRst.RowCount - 1";
{
final int step3 = 1;
final int limit3 = (int) (_tmprst.getRowCount()-1);
_j = (int) (0) ;
for (;(step3 > 0 && _j <= limit3) || (step3 < 0 && _j >= limit3) ;_j = ((int)(0 + _j + step3))  ) {
 //BA.debugLineNum = 106;BA.debugLine="TmpRst.Position = J";
_tmprst.setPosition(_j);
 //BA.debugLineNum = 107;BA.debugLine="Dim lvd As ListViewData";
_lvd = new b4a.example.main._listviewdata();
 //BA.debugLineNum = 108;BA.debugLine="lvd.Initialize";
_lvd.Initialize();
 //BA.debugLineNum = 109;BA.debugLine="lvd.FirstRow = TmpRst.GetString(\"Message\")";
_lvd.FirstRow = _tmprst.GetString("Message");
 //BA.debugLineNum = 110;BA.debugLine="lvd.SecondRow=  TmpRst.GetString(\"AssignTo\")  &";
_lvd.SecondRow = _tmprst.GetString("AssignTo")+" | "+_tmprst.GetString("LogDate");
 //BA.debugLineNum = 111;BA.debugLine="LstMessage.AddTwoLines2(lvd.FirstRow, lvd.Second";
mostCurrent._lstmessage.AddTwoLines2(BA.ObjectToCharSequence(_lvd.FirstRow),BA.ObjectToCharSequence(_lvd.SecondRow),(Object)(_lvd));
 }
};
 //BA.debugLineNum = 113;BA.debugLine="TmpRst.Close";
_tmprst.Close();
 //BA.debugLineNum = 115;BA.debugLine="End Sub";
return "";
}
public static String  _frmtodoentry_click() throws Exception{
 //BA.debugLineNum = 97;BA.debugLine="Sub FrmToDoEntry_Click()";
 //BA.debugLineNum = 98;BA.debugLine="StartActivity(FrmToDoEntry)";
anywheresoftware.b4a.keywords.Common.StartActivity(processBA,(Object)(mostCurrent._frmtodoentry.getObject()));
 //BA.debugLineNum = 99;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 31;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 35;BA.debugLine="Private LstMessage As ListView";
mostCurrent._lstmessage = new anywheresoftware.b4a.objects.ListViewWrapper();
 //BA.debugLineNum = 36;BA.debugLine="Type ListViewData (FirstRow As String, SecondRow";
;
 //BA.debugLineNum = 39;BA.debugLine="End Sub";
return "";
}
public static String  _lstmessage_itemclick(int _position,Object _value) throws Exception{
b4a.example.main._listviewdata _lvd = null;
String[] _secondrow = null;
 //BA.debugLineNum = 118;BA.debugLine="Sub LstMessage_ItemClick (Position As Int, Value A";
 //BA.debugLineNum = 120;BA.debugLine="Dim lvd As ListViewData";
_lvd = new b4a.example.main._listviewdata();
 //BA.debugLineNum = 121;BA.debugLine="Dim SecondRow() As String";
_secondrow = new String[(int) (0)];
java.util.Arrays.fill(_secondrow,"");
 //BA.debugLineNum = 122;BA.debugLine="lvd = Value";
_lvd = (b4a.example.main._listviewdata)(_value);
 //BA.debugLineNum = 123;BA.debugLine="StrMessage = lvd.FirstRow";
_strmessage = _lvd.FirstRow;
 //BA.debugLineNum = 124;BA.debugLine="SecondRow = Regex.Split(\"[|]\",lvd.SecondRow)";
_secondrow = anywheresoftware.b4a.keywords.Common.Regex.Split("[|]",_lvd.SecondRow);
 //BA.debugLineNum = 125;BA.debugLine="StrAssignTo = SecondRow(0)";
_strassignto = _secondrow[(int) (0)];
 //BA.debugLineNum = 126;BA.debugLine="StrDate = SecondRow(1)";
_strdate = _secondrow[(int) (1)];
 //BA.debugLineNum = 127;BA.debugLine="EditMode = True";
_editmode = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 128;BA.debugLine="StartActivity(FrmToDoEntry)";
anywheresoftware.b4a.keywords.Common.StartActivity(processBA,(Object)(mostCurrent._frmtodoentry.getObject()));
 //BA.debugLineNum = 130;BA.debugLine="End Sub";
return "";
}
public static String  _lstmessage_itemlongclick(int _position,Object _value) throws Exception{
int _result = 0;
b4a.example.main._listviewdata _lvd = null;
String[] _secondrow = null;
String _s = "";
 //BA.debugLineNum = 132;BA.debugLine="Sub LstMessage_ItemLongClick (Position As Int, Val";
 //BA.debugLineNum = 134;BA.debugLine="Dim Result As Int";
_result = 0;
 //BA.debugLineNum = 135;BA.debugLine="Result = Msgbox2(\"Do you want to Close this Task?";
_result = anywheresoftware.b4a.keywords.Common.Msgbox2(BA.ObjectToCharSequence("Do you want to Close this Task?"),BA.ObjectToCharSequence("Todo"),"Yes","","No",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null),mostCurrent.activityBA);
 //BA.debugLineNum = 136;BA.debugLine="If Result = DialogResponse.POSITIVE  Then";
if (_result==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
 //BA.debugLineNum = 137;BA.debugLine="Dim lvd As ListViewData";
_lvd = new b4a.example.main._listviewdata();
 //BA.debugLineNum = 138;BA.debugLine="Dim SecondRow() As String";
_secondrow = new String[(int) (0)];
java.util.Arrays.fill(_secondrow,"");
 //BA.debugLineNum = 139;BA.debugLine="lvd = Value";
_lvd = (b4a.example.main._listviewdata)(_value);
 //BA.debugLineNum = 140;BA.debugLine="StrMessage = lvd.FirstRow";
_strmessage = _lvd.FirstRow;
 //BA.debugLineNum = 141;BA.debugLine="SecondRow = Regex.Split(\"[|]\",lvd.SecondRow)";
_secondrow = anywheresoftware.b4a.keywords.Common.Regex.Split("[|]",_lvd.SecondRow);
 //BA.debugLineNum = 142;BA.debugLine="StrAssignTo = SecondRow(0)";
_strassignto = _secondrow[(int) (0)];
 //BA.debugLineNum = 143;BA.debugLine="StrDate = SecondRow(1)";
_strdate = _secondrow[(int) (1)];
 //BA.debugLineNum = 144;BA.debugLine="Dim s As String";
_s = "";
 //BA.debugLineNum = 145;BA.debugLine="ConKha.ExecNonQuery(\"Update Todo Set Active = 1";
_conkha.ExecNonQuery("Update Todo Set Active = 1 Where  (RTrim(LogDate) = '"+_strdate.trim()+"') And (RTrim(AssignTo) = '"+_strassignto.trim()+"') And (RTrim(Message) = '"+_strmessage.trim()+"') ");
 //BA.debugLineNum = 146;BA.debugLine="ExecuteListView";
_executelistview();
 };
 //BA.debugLineNum = 149;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
starter._process_globals();
frmtodomain._process_globals();
frmtodoentry._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="Dim StrModel,StrDeviceCode As String";
_strmodel = "";
_strdevicecode = "";
 //BA.debugLineNum = 20;BA.debugLine="Dim ConKha As SQL";
_conkha = new anywheresoftware.b4a.sql.SQL();
 //BA.debugLineNum = 21;BA.debugLine="Dim TmpRst As Cursor";
_tmprst = new anywheresoftware.b4a.sql.SQL.CursorWrapper();
 //BA.debugLineNum = 23;BA.debugLine="Dim StrDataPath As String";
_strdatapath = "";
 //BA.debugLineNum = 24;BA.debugLine="Dim StrReport_Path,StrRpt,StrFileName As String";
_strreport_path = "";
_strrpt = "";
_strfilename = "";
 //BA.debugLineNum = 25;BA.debugLine="Dim OS As OperatingSystem";
_os = new com.rootsoft.oslibrary.OSLibrary();
 //BA.debugLineNum = 26;BA.debugLine="Dim StrMessage,StrAssignTo,StrDate As String";
_strmessage = "";
_strassignto = "";
_strdate = "";
 //BA.debugLineNum = 27;BA.debugLine="Dim EditMode As Boolean";
_editmode = false;
 //BA.debugLineNum = 29;BA.debugLine="End Sub";
return "";
}
}
