package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class frmtodoentry extends Activity implements B4AActivity{
	public static frmtodoentry mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.frmtodoentry");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (frmtodoentry).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, false))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.frmtodoentry");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.frmtodoentry", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (frmtodoentry) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (frmtodoentry) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return frmtodoentry.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (frmtodoentry) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (frmtodoentry) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.SpinnerWrapper _cboassigned = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtmessage = null;
public anywheresoftware.b4a.agraham.dialogs.InputDialog _id = null;
public anywheresoftware.b4a.objects.ButtonWrapper _cmdpick = null;
public anywheresoftware.b4a.objects.EditTextWrapper _txtdate = null;
public b4a.example.main _main = null;
public b4a.example.starter _starter = null;
public b4a.example.frmtodomain _frmtodomain = null;

public static void initializeProcessGlobals() {
             try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
}
public static String  _activity_create(boolean _firsttime) throws Exception{
String _strdate = "";
int _i = 0;
long _t = 0L;
 //BA.debugLineNum = 26;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 28;BA.debugLine="Activity.LoadLayout(\"FrmToDo\")";
mostCurrent._activity.LoadLayout("FrmToDo",mostCurrent.activityBA);
 //BA.debugLineNum = 30;BA.debugLine="Dim StrDate As String";
_strdate = "";
 //BA.debugLineNum = 31;BA.debugLine="DateTime.DateFormat = \"dd/MM/yyyy\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("dd/MM/yyyy");
 //BA.debugLineNum = 32;BA.debugLine="TxtDate.Text = DateTime.Date(DateTime.Now)";
mostCurrent._txtdate.setText(BA.ObjectToCharSequence(anywheresoftware.b4a.keywords.Common.DateTime.Date(anywheresoftware.b4a.keywords.Common.DateTime.getNow())));
 //BA.debugLineNum = 33;BA.debugLine="TxtMessage.Text = \"\"";
mostCurrent._txtmessage.setText(BA.ObjectToCharSequence(""));
 //BA.debugLineNum = 34;BA.debugLine="ExecuteCombo";
_executecombo();
 //BA.debugLineNum = 36;BA.debugLine="If Main.EditMode = True Then";
if (mostCurrent._main._editmode==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 38;BA.debugLine="For I = 0 To CboAssigned.Size -1";
{
final int step8 = 1;
final int limit8 = (int) (mostCurrent._cboassigned.getSize()-1);
_i = (int) (0) ;
for (;(step8 > 0 && _i <= limit8) || (step8 < 0 && _i >= limit8) ;_i = ((int)(0 + _i + step8))  ) {
 //BA.debugLineNum = 39;BA.debugLine="If CboAssigned.GetItem(I) = Main.StrAssignTo  T";
if ((mostCurrent._cboassigned.GetItem(_i)).equals(mostCurrent._main._strassignto)) { 
 //BA.debugLineNum = 40;BA.debugLine="CboAssigned.SelectedIndex = I";
mostCurrent._cboassigned.setSelectedIndex(_i);
 };
 }
};
 //BA.debugLineNum = 43;BA.debugLine="TxtMessage.Text = Main.StrMessage";
mostCurrent._txtmessage.setText(BA.ObjectToCharSequence(mostCurrent._main._strmessage));
 //BA.debugLineNum = 44;BA.debugLine="Dim t As Long";
_t = 0L;
 //BA.debugLineNum = 45;BA.debugLine="DateTime.DateFormat = \"yyyy-MM-dd\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("yyyy-MM-dd");
 //BA.debugLineNum = 46;BA.debugLine="t = DateTime.DateParse(Main.StrDate)";
_t = anywheresoftware.b4a.keywords.Common.DateTime.DateParse(mostCurrent._main._strdate);
 //BA.debugLineNum = 47;BA.debugLine="DateTime.DateFormat = \"dd/MM/yyyy\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("dd/MM/yyyy");
 //BA.debugLineNum = 48;BA.debugLine="TxtDate.Text = Main.StrDate";
mostCurrent._txtdate.setText(BA.ObjectToCharSequence(mostCurrent._main._strdate));
 };
 //BA.debugLineNum = 52;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 94;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 96;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 90;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 92;BA.debugLine="End Sub";
return "";
}
public static String  _cboassigned_itemclick(int _position,Object _value) throws Exception{
int _ret = 0;
 //BA.debugLineNum = 98;BA.debugLine="Sub CboAssigned_ItemClick (Position As Int, Value";
 //BA.debugLineNum = 100;BA.debugLine="If CboAssigned.SelectedItem = \"Select here to Add";
if ((mostCurrent._cboassigned.getSelectedItem()).equals("Select here to Add new Person")) { 
 //BA.debugLineNum = 101;BA.debugLine="Dim ret As Int";
_ret = 0;
 //BA.debugLineNum = 102;BA.debugLine="ret = Id.Show(\"Enter Name\", \"Todo\", \"OK\", \"Cance";
_ret = mostCurrent._id.Show("Enter Name","Todo","OK","Cancel","",mostCurrent.activityBA,(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null));
 //BA.debugLineNum = 103;BA.debugLine="If ret = DialogResponse.POSITIVE Then";
if (_ret==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
 //BA.debugLineNum = 104;BA.debugLine="If Id.Input <> \"\" Then";
if ((mostCurrent._id.getInput()).equals("") == false) { 
 //BA.debugLineNum = 105;BA.debugLine="Main.ConKha.ExecNonQuery(\"Delete from UserMast";
mostCurrent._main._conkha.ExecNonQuery("Delete from UserMaster Where UserName = '"+mostCurrent._id.getInput()+"' ");
 //BA.debugLineNum = 106;BA.debugLine="Main.ConKha.ExecNonQuery(\"Insert Into UserMast";
mostCurrent._main._conkha.ExecNonQuery("Insert Into UserMaster Values('"+mostCurrent._id.getInput()+"')");
 //BA.debugLineNum = 107;BA.debugLine="ExecuteCombo";
_executecombo();
 };
 };
 };
 //BA.debugLineNum = 113;BA.debugLine="End Sub";
return "";
}
public static String  _cmdpick_click() throws Exception{
anywheresoftware.b4a.agraham.dialogs.InputDialog.DateDialog _dd = null;
String _thedate = "";
String _ret = "";
 //BA.debugLineNum = 116;BA.debugLine="Sub CmdPick_Click";
 //BA.debugLineNum = 118;BA.debugLine="Dim Dd As DateDialog";
_dd = new anywheresoftware.b4a.agraham.dialogs.InputDialog.DateDialog();
 //BA.debugLineNum = 119;BA.debugLine="Dim thedate As String";
_thedate = "";
 //BA.debugLineNum = 122;BA.debugLine="Dd.Year = DateTime.GetYear(DateTime.Now)";
_dd.setYear(anywheresoftware.b4a.keywords.Common.DateTime.GetYear(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 123;BA.debugLine="Dd.Month = DateTime.GetMonth(DateTime.Now)";
_dd.setMonth(anywheresoftware.b4a.keywords.Common.DateTime.GetMonth(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 124;BA.debugLine="Dd.DayOfMonth = DateTime.GetDayOfMonth(DateTime.N";
_dd.setDayOfMonth(anywheresoftware.b4a.keywords.Common.DateTime.GetDayOfMonth(anywheresoftware.b4a.keywords.Common.DateTime.getNow()));
 //BA.debugLineNum = 125;BA.debugLine="ret = Dd.Show(\"Set the required date\", \"Todo Date";
_ret = BA.NumberToString(_dd.Show("Set the required date","Todo Date","Yes","No","",mostCurrent.activityBA,(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null)));
 //BA.debugLineNum = 128;BA.debugLine="thedate = NumberFormat(Dd.DayOfMonth,2,0) & \"-\" &";
_thedate = anywheresoftware.b4a.keywords.Common.NumberFormat(_dd.getDayOfMonth(),(int) (2),(int) (0))+"-"+anywheresoftware.b4a.keywords.Common.NumberFormat(_dd.getMonth(),(int) (2),(int) (0))+"-"+BA.NumberToString(_dd.getYear());
 //BA.debugLineNum = 129;BA.debugLine="TxtDate.Text = thedate";
mostCurrent._txtdate.setText(BA.ObjectToCharSequence(_thedate));
 //BA.debugLineNum = 131;BA.debugLine="End Sub";
return "";
}
public static String  _cmdsave_click() throws Exception{
String _strdate = "";
long _t = 0L;
 //BA.debugLineNum = 66;BA.debugLine="Sub CmdSave_Click";
 //BA.debugLineNum = 68;BA.debugLine="Dim StrDate As String";
_strdate = "";
 //BA.debugLineNum = 70;BA.debugLine="DateTime.DateFormat = \"dd/MM/yyyy\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("dd/MM/yyyy");
 //BA.debugLineNum = 71;BA.debugLine="Dim t As Long";
_t = 0L;
 //BA.debugLineNum = 72;BA.debugLine="t = DateTime.DateParse(TxtDate.Text)";
_t = anywheresoftware.b4a.keywords.Common.DateTime.DateParse(mostCurrent._txtdate.getText());
 //BA.debugLineNum = 73;BA.debugLine="DateTime.DateFormat = \"yyyy-MM-dd\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("yyyy-MM-dd");
 //BA.debugLineNum = 75;BA.debugLine="StrDate = DateTime.Date(t)";
_strdate = anywheresoftware.b4a.keywords.Common.DateTime.Date(_t);
 //BA.debugLineNum = 79;BA.debugLine="If CboAssigned.SelectedItem = \"Select here to Add";
if ((mostCurrent._cboassigned.getSelectedItem()).equals("Select here to Add new Person") || (mostCurrent._txtmessage.getText()).equals("")) { 
 //BA.debugLineNum = 80;BA.debugLine="Msgbox(\"Please Enter Data\",\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(BA.ObjectToCharSequence("Please Enter Data"),BA.ObjectToCharSequence(""),mostCurrent.activityBA);
 }else {
 //BA.debugLineNum = 82;BA.debugLine="Main.ConKha.ExecNonQuery(\"Delete from Todo Where";
mostCurrent._main._conkha.ExecNonQuery("Delete from Todo Where (RTrim(LogDate) = '"+_strdate.trim()+"') And (RTrim(AssignTo) = '"+mostCurrent._cboassigned.getSelectedItem().trim()+"') And (RTrim(Message) = '"+mostCurrent._txtmessage.getText().trim()+"') ");
 //BA.debugLineNum = 83;BA.debugLine="Main.ConKha.ExecNonQuery(\"Insert Into Todo Value";
mostCurrent._main._conkha.ExecNonQuery("Insert Into Todo Values('"+_strdate+"','"+mostCurrent._cboassigned.getSelectedItem()+"','"+mostCurrent._txtmessage.getText()+"',0)");
 //BA.debugLineNum = 84;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 88;BA.debugLine="End Sub";
return "";
}
public static String  _executecombo() throws Exception{
int _j = 0;
 //BA.debugLineNum = 54;BA.debugLine="Sub ExecuteCombo()";
 //BA.debugLineNum = 56;BA.debugLine="CboAssigned.Clear";
mostCurrent._cboassigned.Clear();
 //BA.debugLineNum = 57;BA.debugLine="CboAssigned.Add(\"Select here to Add new Person\")";
mostCurrent._cboassigned.Add("Select here to Add new Person");
 //BA.debugLineNum = 58;BA.debugLine="Main.TmpRst = Main.ConKha.ExecQuery(\"Select UserN";
mostCurrent._main._tmprst.setObject((android.database.Cursor)(mostCurrent._main._conkha.ExecQuery("Select UserName from UserMaster Order by 1")));
 //BA.debugLineNum = 59;BA.debugLine="For J = 0 To Main.TmpRst.RowCount - 1";
{
final int step4 = 1;
final int limit4 = (int) (mostCurrent._main._tmprst.getRowCount()-1);
_j = (int) (0) ;
for (;(step4 > 0 && _j <= limit4) || (step4 < 0 && _j >= limit4) ;_j = ((int)(0 + _j + step4))  ) {
 //BA.debugLineNum = 60;BA.debugLine="Main.TmpRst.Position = J";
mostCurrent._main._tmprst.setPosition(_j);
 //BA.debugLineNum = 61;BA.debugLine="CboAssigned.Add(Main.TmpRst.GetString(\"UserName\"";
mostCurrent._cboassigned.Add(mostCurrent._main._tmprst.GetString("UserName"));
 }
};
 //BA.debugLineNum = 63;BA.debugLine="Main.TmpRst.Close";
mostCurrent._main._tmprst.Close();
 //BA.debugLineNum = 64;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 17;BA.debugLine="Private CboAssigned As Spinner";
mostCurrent._cboassigned = new anywheresoftware.b4a.objects.SpinnerWrapper();
 //BA.debugLineNum = 18;BA.debugLine="Private TxtMessage As EditText";
mostCurrent._txtmessage = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 19;BA.debugLine="Dim Id As InputDialog";
mostCurrent._id = new anywheresoftware.b4a.agraham.dialogs.InputDialog();
 //BA.debugLineNum = 21;BA.debugLine="Private CmdPick As Button";
mostCurrent._cmdpick = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 22;BA.debugLine="Private TxtDate As EditText";
mostCurrent._txtdate = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 6;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 10;BA.debugLine="End Sub";
return "";
}
}
